%%% Regions is assumed to have come directly from reading a PGM image,
%%% so it has values of zero.
function [dmx, dmy] = create_dm(regions, motions)

sz = size(regions);
nregions = size(motions,1);

%%% Check consistency of inputs
if min(min(regions))<0, error('Regions must be nonnegative'), end
if min(min(regions))~=0, warning('Why is there no region 0?'), end
if max(max(regions))>=nregions, error('Label is too high'), end

[x,y] = meshgrid(0:sz(2)-1,0:sz(1)-1);

dmx = zeros(sz);
dmy = zeros(sz);

for i=1:nregions,
	disp(['Creating dispmap ' num2str(i) '/' num2str(nregions)])
     mask = regions==(i-1);
     [ii,jj] = find(mask);
     valid_cols = [min(min(jj)) : max(max(jj))];
     valid_rows = [min(min(ii)) : max(max(ii))];
     xx = x(valid_rows,valid_cols);
     yy = y(valid_rows,valid_cols);
     mask = mask(valid_rows,valid_cols);
     m = motions(i,:);
	dx = m(1)*xx + m(2)*yy + m(3);
	dy = m(4)*xx + m(5)*yy + m(6);
	dmx(valid_rows,valid_cols) = dmx(valid_rows,valid_cols) + mask.*dx;
	dmy(valid_rows,valid_cols) = dmy(valid_rows,valid_cols) + mask.*dy;
end

if any(abs(dmy)>0.5), 
	warning('Large Vertical shift -- I hope this is not a stereo pair')
	max(max(abs(dmy)))
end
